﻿//Copyright (c) 2015 Joseph W. Barker
//MIT License
using System;

using Sandbox;
using Sandbox.Common;
using Sandbox.Common.Components;
using Sandbox.Common.ObjectBuilders;
using Sandbox.Definitions;
using Sandbox.Engine;
using Sandbox.Game;
using Sandbox.Game.Entities;
using Sandbox.Game.Entities.Character;
using Sandbox.Game.World;
using Sandbox.ModAPI;
using Ingame=Sandbox.ModAPI.Ingame;

namespace InterGridComms
{
    [MyEntityComponentDescriptor(typeof(MyObjectBuilder_Character))]
    public class CharacterTracker : MyGameLogicComponent
    {
        private MyObjectBuilder_EntityBase m_objectBuilder;

        public override void Init(MyObjectBuilder_EntityBase objectBuilder)
        {
            m_objectBuilder=objectBuilder;

            Entity.NeedsUpdate |= MyEntityUpdateEnum.BEFORE_NEXT_FRAME;
        }

        public override void UpdateOnceBeforeFrame()
        {
            IGC.Instance.RegisterCharacter(Entity);
        }

        public override MyObjectBuilder_EntityBase GetObjectBuilder(bool copy)
        {
            return m_objectBuilder;
        }

        public override void MarkForClose()
        {
            if(IGC.Instance!=null) IGC.Instance.UnregisterCharacter(Entity);
            base.MarkForClose();
        }

        public override void Close()
        {
            if(IGC.Instance!=null) IGC.Instance.UnregisterCharacter(Entity);
            base.Close();
        }
    }
}
